/*\
 * Boot:
 * Just what is strictly necessary to do some testing.
 * The .org values are specified in the MicroBlaze data-sheet.
\*/
	.extern __start
	.extern _stack_top
	.globl  __boot
	.ent    __boot

        .org 0x00
__boot:	
        bri .Lgo
	
        .org 0x08
_exception_handler:
        bri _exception_handler
	
        .org 0x10
_interrupt_handler:
        bri __interrupt_handler

        .org 0x18
_break_handler:
        bri _break_handler

        .org 0x20
_hw_exception_handler:
        bri _hw_exception_handler
	
        .text
        .org 0x50
.Lgo:
	/* Set stack-top for all CPUs */
	get     r3, r0
	/* Allocate 2^12 bytes per stack => shift 12 times */
	addk r3,r3,r3 /* Microblaze doesn't have 'shift', but: x << 2 == x + x */
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	addk r3,r3,r3
	rsubk r3, r3, r0
	addik r1, r3, _stack_top
        /*
         * Enables interrupts 
         */
        ori     r3, r0, 2
        mts     rmsr, r3
	bri     __start
_boot_end:
	bri 	_boot_end
	.end	_boot
	
